'use strict'
import echarts from 'echarts'
export let initCharts = function (o) {
    let option = {
        title: {
            text: o.text.name || "",
            left: o.text.left||'left',
            textStyle:{
                color:o.text.color || '#0000'
            },
            show:o.text.show
        },
        legend: {
            data: o.legend.data || [],
            top:o.legend.top || 0,
            left:o.legend.left || 0,
        },
        tooltip: Object.assign({trigger: 'axis'}, o.tooltip || {}
        ),
        grid: Object.assign({
            top: 40,
            bottom: 50,
            left: 20,
            right: 20,
            containLabel: true //决定的是包括了坐标轴标签在内的所有内容所形成的矩形的位置
        }, o.grid || {}),
        visualMap:o.visualMap||[],
        xAxis: {
            type:'category',
            data:o.xAxis.data.map(v=>{
                return{
                    value:v,
                }
            }),
            name:o.xAxis.name.name||{},
            nameTextStyle:{
                color:o.xAxis.name.color || '#0000'
            },
        },
        yAxis:{
            type:'value',
            name:o.yAxis.name.name||{},
            nameTextStyle:{
                color:o.yAxis.name.color|| '#0000'
            },

        },
        series: o.series && o.series.length >0 &&o.series.map((v) => {
            return Object.assign(v,{type: o.type})
        }) || [],
    };
    o.color && (option.color = o.color)
    option.dataZoom = [
        Object.assign({type: 'inside', start: 0, end: 100,zoomLock:o.zoomLock?true:false},o.dataZoomInside||{}),
        Object.assign({
            type: 'slider',
            textStyle:{color:o.dataZoom.color || '#333'},
            start: 0, //数据窗口范围的起始百分比。范围是：0 ~ 100。
            end: 100,   //数据窗口范围的结束百分比。范围是：0 ~ 100。
            handleIcon: 'M10.7,11.9v-1.3H9.3v1.3c-4.9,0.3-8.8,4.4-8.8,9.4c0,5,3.9,9.1,8.8,9.4v1.3h1.3v-1.3c4.9-0.3,8.8-4.4,8.8-9.4C19.5,16.3,15.6,12.2,10.7,11.9z M13.3,24.4H6.7V23h6.6V24.4z M13.3,19.6H6.7v-1.4h6.6V19.6z',
        }, o.dataZoomPos || {}),
    ]
    setTimeout(function () {
        let myChart = echarts.init(document.getElementById(o.id))
        myChart.setOption(option);
    },10)
}
