import Vue from 'vue'
import Router from 'vue-router'
import Home from './views/Home.vue'

Vue.use(Router)

//某个路由下的所有组件都打包在同个异步块 (chunk) 中。只需要使用命名chunk，一个特殊的注释语法来提供chunk name (需要 Webpack > 2.4)。
const loginManage = () => import(/* webpackChunkName: "loginManage" */  '@/views/login.vue')
//vpn设备管理
const deviceManage = () => import(/* webpackChunkName: "deviceManage" */ '@/views/vpnDeviceManage.vue')
//vpn管理
const vpnManage = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnManage.vue')
//vpn 拓扑图
const vpnTopu = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnTopu.vue')
//vpn 关联设备
const vpnADMap = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnADMap.vue')
//vpn添加设备
const vpnADTable = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnADTable.vue')
//vpn 业务管理
const workManage = () => import(/* webpackChunkName: "workManage" */ '@/views/vpnWorkManage.vue')
//vpn 业务拓扑图或者列表
const topoWorkManage = () => import(/* webpackChunkName: "topoWorkManage" */ '@/views/work/topologyWork.vue')
//网络资产
const netWorkAssets = () => import(/* webpackChunkName: "netWorkAssets" */ '@/views/assets/netWorkAssets.vue')
const  oidAssets = () => import(/* webpackChunkName: "oidAssets" */ '@/views/assets/oidAssets.vue')
//vpn 设备发现
const facilityManage = () => import('@/views/facility/facilityManage.vue')
//vpn 设备查询
const deviceList = () => import('@/views/facility/deviceList.vue')
//vpn 操作日志
const operationLog = () => import('@/views/facility/operationLog.vue')
//vpn 告警日志
const warnLog = () => import('@/views/facility/warnLog.vue')
//vpn 设备备份
const deviceConfigBackup = () => import( '@/views/facility/deviceConfigBackup.vue')
const deviceconfigManager =() => import('@/components/deviceconfigTemplate/deviceconfigManager.vue')
//vpn 设备自动配置
const deviceConfiguration = () => import( '@/views/facility/deviceConfiguration.vue')
//vpn 设备自动上线
const deviceConfigOnline = () => import( '@/views/facility/deviceConfigOnline.vue')
//加油站场景
const gasStationScene = () => import( '@/components/gasStationScene/gasStationScene.vue')
//配置源
const configTemplate = () => import('@/views/config/configTemplate.vue')
const configFile = () => import( '@/views/config/configFile.vue')
const configFileAddOrUpdate =() =>import('@/components/configFile/FileAddOrUpdate.vue')
//自动上线
const ipresource =() =>import('@/views/facility/ipresource.vue')
//企业管理
const businessAdmin =() =>import('@/views/facility/businessAdmin.vue')
const businessAdmininif =() =>import('@/components/businessAdmin/add-businessAdmin.vue')

// 用户管理
const userControl =() =>import('@/views/facility/userControl.vue')

//vpn 设备自动升级
const deviceUpgrade = () => import( '@/views/facility/deviceUpgrade.vue')
//修改密码
const updatePas =()=>import('@/views/user/updatePas.vue');
const userInfo =()=>import('@/views/user/userInfo.vue')

const isReqiureLogin = true;
const notRequireLOgin = false;
const router = new Router({
  mode: 'history',
  base: process.env.BASE_URL,
  routes: [
  {
      path: '/',
      redirect:'login'
  },
   {
       path: '/login',
       name:'login',
       component:loginManage,
   },
   {
      path: '/home',
      component: Home,
      children:[
          {
              path: '/device',
              name: 'deviceManage',
              component:deviceManage,
              meta: {requireLogin: isReqiureLogin },
          },
          {
              path: '/vpn',
              name: 'vpnManage',
              component:vpnManage,
              meta: {requireLogin: isReqiureLogin },
          },
          {
              path: '/vpnTopu',
              name: 'vpnTopu',
              component:vpnTopu,
              meta: {requireLogin: isReqiureLogin },
          },
          {
              path: '/vpnADMap',
              name: 'vpnADMap',
              component:vpnADMap,
              meta: {requireLogin: isReqiureLogin },
          },
          {
              path: '/vpnADTable',
              name: 'vpnADTable',
              component:vpnADTable,
              meta: {requireLogin: isReqiureLogin },
          },
          {
              path: '/work',
              name: 'workManage',
              component:workManage,
              meta: {requireLogin: isReqiureLogin },
          },
          {
              path: '/workManage',
              name: 'topoWorkManage',
              component:topoWorkManage,
              meta: {requireLogin: isReqiureLogin },
          },{
              path: '/netAssets',
              name: 'netWorkAssets',
              component:netWorkAssets,
              meta: {requireLogin: isReqiureLogin },
          },{
              path: '/oidAssets',
              name: 'oidAssets',
              component:oidAssets,
              meta: {requireLogin: isReqiureLogin },
        },{
            path: '/facilitys',
            name: 'facilitys',
            component:facilityManage,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/devicequery',
            name: 'devicequery',
            component:deviceList,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/operationLog',
            name: 'operationLog',
            component:operationLog,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/warnLog',
            name: 'warnLog',
            component:warnLog,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/configTemplate',
            name: 'configTemplate',
            component:configTemplate,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/deviceConfigBackup',
            name: 'deviceConfigBackup',
            component:deviceConfigBackup,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/deviceConfiguration',
            name: 'deviceConfiguration',
            component:deviceConfiguration,
            meta: {requireLogin: isReqiureLogin },
        },{
            path: '/configFile',
            name: 'configFile',
            component:configFile,
              meta: {requireLogin: isReqiureLogin },
        }, {
            path: '/ipresource',
            name: 'ipresource',
            component:ipresource,
            meta: {requireLogin: isReqiureLogin },
        }, {
            path:'/configFileAddOrUpdate',
            component:configFileAddOrUpdate,
            name:"configFileAddOrUpdate",
            meta: {requireLogin: isReqiureLogin },
        }, {
            path:'/deviceconfigManager',
            component:deviceconfigManager,
            meta: {requireLogin: isReqiureLogin },
        }, {
            path:'/deviceConfigOnline',
            component:deviceConfigOnline,
            meta: {requireLogin: isReqiureLogin },
        }, {
            path:'/userControl',
            component:userControl,
            meta: {requireLogin: isReqiureLogin },
        }, {
            path:'/businessAdmin',
            component:businessAdmin,
            meta: {requireLogin: isReqiureLogin },
        }, {
            path:'/businessAdmininif',
            component:businessAdmininif,
            meta: {requireLogin: isReqiureLogin },
        }, {//自动上线加油站场景
            path:'/gasStationScene',
            name: 'gasStationScene',
            component:gasStationScene,
            meta: {requireLogin: isReqiureLogin },
        },
        {
            path:'/deviceUpgrade',
            name:"deviceUpgrade",
            component:deviceUpgrade,
            meta: {requireLogin: isReqiureLogin },
        },
        {
            path:'/updatePas',
            name:'updatePas',
            component:updatePas,
            meta: {requireLogin: isReqiureLogin }
        },
        {
            path:'/userInfo',
            name:'userInfo',
            component:userInfo,
            meta: {requireLogin: isReqiureLogin }
            }
    ]
    },
  ]
})
router.beforeEach((to, from, next) => {
    if(to.meta.requireLogin){
        next();
        let token = localStorage.getItem("token");
        if (token) {  // 通过vuex state获取当前的token是否存在
            return next();
        }else {
            next({  path: '/', query: {redirect:to.fullPath}})
        }
    }else {
        next();
    }
})
export default  router
