/**
 * Created by supervisor on 2019/6/20
 */

import Vue from 'vue'
import Router from 'vue-router'
import Home from '../views/Home.vue'
import routes from './modules/fos'
Vue.use(Router)

//某个路由下的所有组件都打包在同个异步块 (chunk) 中。只需要使用命名chunk，一个特殊的注释语法来提供chunk name (需要 Webpack > 2.4)。
const loginManage = () => import(/* webpackChunkName: "loginManage" */  '@/views/login.vue')
//认证页
const approvePage = () => import(/* webpackChunkName: "loginManage" */  '@/views/approve.vue')
//首页
const mainPage = r => require.ensure([],()=>r(require(/* webpackChunkName: "mainPage" */ '@/views/fos/mainPage')),'mainPage');
const auxiliaryPage = r => require.ensure([],()=>r(require(/* webpackChunkName: "auxiliaryPage" */ '@/views/fos/auxiliaryPage')),'auxiliaryPage');
const mainPageArea = r => require.ensure([],()=>r(require(/* webpackChunkName: "mainPageArea" */ '@/views/fos/mainPageArea')),'mainPageArea');

//vpn设备管理
const deviceManage = () => import(/* webpackChunkName: "deviceManage" */ '@/views/vpnDeviceManage.vue')
//vpn管理
const vpnManage = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnManage.vue')
//vpn 拓扑图
const vpnTopu = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnTopu.vue')
//vpn 关联设备
const vpnADMap = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnADMap.vue')
//vpn添加设备
const vpnADTable = () => import(/* webpackChunkName: "vpnManage" */ '@/views/vpn/vpnADTable.vue')
//vpn 业务管理
const workManage = () => import(/* webpackChunkName: "workManage" */ '@/views/vpnWorkManage.vue')
//vpn 业务拓扑图或者列表
const topoWorkManage = () => import(/* webpackChunkName: "topoWorkManage" */ '@/views/work/topologyWork.vue')
//网络资产
const netWorkAssets = () => import(/* webpackChunkName: "netWorkAssets" */ '@/views/assets/netWorkAssets.vue')
const  oidAssets = () => import(/* webpackChunkName: "oidAssets" */ '@/views/assets/oidAssets.vue')
//vpn 设备发现
const facilityManage = () => import('@/views/facility/facilityManage.vue')
//vpn 设备查询
const deviceList = () => import('@/views/facility/deviceList.vue')
//vpn 操作日志
const operationLog = () => import('@/views/facility/operationLog.vue')
//vpn 告警日志
const warnLog = () => import('@/views/facility/warnLog.vue')
//vpn 设备备份
const deviceConfigBackup = () => import( '@/views/facility/deviceConfigBackup.vue')
const deviceconfigManager =() => import('@/components/deviceconfigTemplate/deviceconfigManager.vue')
//vpn 设备自动配置
const deviceConfiguration = () => import( '@/views/facility/deviceConfiguration.vue')
//vpn 设备自动上线
const deviceConfigOnline = () => import( '@/views/facility/deviceConfigOnline.vue')
//加油站场景
const gasStationScene = () => import( '@/components/gasStationScene/gasStationScene.vue')
//配置源
const configTemplate = () => import('@/views/config/configTemplate.vue')
const configFile = () => import( '@/views/config/configFile.vue')
const configFileAddOrUpdate =() =>import('@/components/configFile/FileAddOrUpdate.vue')
//自动上线
const ipresource =() =>import('@/views/facility/ipresource.vue')
//企业管理
const businessAdmin =() =>import('@/views/facility/businessAdmin.vue')
const businessAdmininif =() =>import('@/components/businessAdmin/add-businessAdmin.vue')

// 用户管理
const userControl =() =>import('@/views/facility/userControl.vue')

//vpn 设备自动升级
const deviceUpgrade = () => import( '@/views/facility/deviceUpgrade.vue')
//修改密码
const updatePas =()=>import('@/views/user/updatePas.vue');
const userInfo =()=>import('@/views/user/userInfo.vue')
const deviceAutoOnline =()=>import('@/views/facility/deviceConfigOnline.vue')

const entWarning = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/entWarning.vue')),'entWarning');
const etpWarning = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/etpWarning.vue')),'etpWarning');

const isReqiureLogin = false;
const notRequireLOgin = false;
const router = new Router({
    mode: 'history',
    base: process.env.BASE_URL,
    routes: [
        {
            path: '/',
            redirect:'login'
        },
        // {
        //     path: '/',
        //     redirect:'approve'
        // },
        {
            path: '/login',
            name:'login',
            component:loginManage,
        },
        {
            path: '/approve',
            name:'approve',
            component:approvePage,
        },
        {
            path: '/home',
            component: Home,
            children:[
                {
                    path: '/mainPage',
                    name: ['首页'],
                    component:mainPage,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/entWarning',
                    name: ['首页','业务告警'],
                    component:entWarning,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/etpWarning',
                    name: ['首页','链路告警'],
                    component:etpWarning,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/auxiliaryPage',
                    name: 'auxiliaryPage',
                    component:auxiliaryPage,
                    meta: {requireLogin: isReqiureLogin },
                },
              {
                    path: '/mainPageArea',
                    name: 'mainPageArea',
                    component:mainPageArea,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/device',
                    name: ['MPLS VPN管理','设备管理'],
                    component:deviceManage,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/instance',
                    name: ['MPLS VPN管理','vpn管理'],
                    component:vpnManage,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/vpnTopu',
                    name: 'vpnTopu',
                    component:vpnTopu,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/vpnADMap',
                    name: 'vpnADMap',
                    component:vpnADMap,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/vpnADTable',
                    name: 'vpnADTable',
                    component:vpnADTable,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/business',
                    name: ['MPLS VPN管理','业务管理'],
                    component:workManage,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path: '/workManage',
                    name: 'topoWorkManage',
                    component:topoWorkManage,
                    meta: {requireLogin: isReqiureLogin },
                },
              {
                    path: '/netasset',
                    name: ['资产管理','网络资产'],
                    component:netWorkAssets,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/oidasset',
                    name: ['资产管理','资产OID'],
                    component:oidAssets,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/discovery',
                    name: ['设备管理','设备发现'],
                    component:facilityManage,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/equipment',
                    name: ['设备管理','设备清单'],
                    component:deviceList,
                    meta: {requireLogin: isReqiureLogin },
                },
                 {
                    path: '/deviceAutoOnline',
                    name: ['设备管理','设备自动上线'],
                    component:deviceAutoOnline,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/operationLog',
                    name: ['日志管理','操作日志'],
                    component:operationLog,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/warnLog',
                    name: ['日志管理','告警日志'],
                    component:warnLog,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/template',
                    name: ['配置源','配置模版'],
                    component:configTemplate,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/deviceConfigBackup',
                    name: ['自动运维','设备配置备份'],
                    component:deviceConfigBackup,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/deviceAutoConfig',
                    name: ['自动运维','设备自动配置'],
                    component:deviceConfiguration,
                    meta: {requireLogin: isReqiureLogin },
                },{
                    path: '/config',
                    name: ['配置源','配置文件'],
                    component:configFile,
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path: '/ippool',
                    name: ['资源池管理','ip资源池'],
                    component:ipresource,
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path:'/configFileAddOrUpdate',
                    component:configFileAddOrUpdate,
                    name:"configFileAddOrUpdate",
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path:'/osversion',
                    component:deviceconfigManager,
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path:'/deviceConfigOnline',
                    component:deviceConfigOnline,
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path:'/usermanage',
                    name: ['设备管理','用户管理'],
                    component:userControl,
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path:'/company',
                    name: ['系统管理','企业管理'],
                    component:businessAdmin,
                    meta: {requireLogin: isReqiureLogin },
                }, {
                    path:'/businessAdmininif',
                    component:businessAdmininif,
                    meta: {requireLogin: isReqiureLogin },
                }, {//自动上线加油站场景
                    path:'/gasStationScene',
                    name: 'gasStationScene',
                    component:gasStationScene,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path:'/deviceupgrade',
                    name:['资源池管理','设备系统版本'],
                    component:deviceUpgrade,
                    meta: {requireLogin: isReqiureLogin },
                },
                {
                    path:'/updatePas',
                    name:'updatePas',
                    component:updatePas,
                    meta: {requireLogin: isReqiureLogin }
                },
                {
                    path:'/userInfo',
                    name:'userInfo',
                    component:userInfo,
                    meta: {requireLogin: isReqiureLogin }
                },
                ...routes
            ]
        },
    ]
})
router.beforeEach((to, from, next) => {
    if(to.meta.requireLogin){
        next();
        let token = localStorage.getItem("token");
        if (token) {  // 通过vuex state获取当前的token是否存在
            return next();
        }else {
            next({  path: '/', query: {redirect:to.fullPath}})
        }
    }else {
        next();
    }
})
export default  router
