/**
 * Created by supervisor on 2019/6/21
 */
//某个路由下的所有组件都打包在同个异步块 (chunk) 中。只需要使用命名chunk，一个特殊的注释语法来提供chunk name (需要 Webpack > 2.4)。

//用户管理
const roleManage = r => require.ensure([],()=>r(require('@/views/fos/systermManagement/roleManage')),'roleManage');

//咨询审核
const dataCenter = r => require.ensure([],()=>r(require('@/views/fos/regionalManagement/dataCenter')),'dataCenter');

//直推用户管理
const areaCenter = r => require.ensure([],()=>r(require('@/views/fos/regionalManagement/areaCenter')),'areaCenter');

//团队用户管理
const businessManagement = r => require.ensure([],()=>r(require('@/views/fos/regionalManagement/businessManagement')),'businessManagement');

//培育奖管理
const appManagement = r => require.ensure([],()=>r(require('@/views/fos/applicationRelated/appManagement')),'appManagement');

//培育奖记录管理
const createManager = r => require.ensure([],()=>r(require('@/views/fos/systermManagement/createManager')),'createManager');

//会员等级优惠
const appClassManagement = r => require.ensure([],()=>r(require('@/views/fos/applicationRelated/appClassManagement')),'appClassManagement');

//月度奖励管理
const applicationDocuments = r => require.ensure([],()=>r(require('@/views/fos/applicationStatus/applicationDocuments')),'applicationDocuments');

//每月进步奖
const toDoList = r => require.ensure([],()=>r(require('@/views/fos/applicationStatus/toDoList')),'toDoList');

//团队业绩管理
const appStreamQuery = r => require.ensure([],()=>r(require('@/views/fos/flowOptimization/appStreamQuery')),'appStreamQuery');

//交易流水管理
const parameterSetting = r => require.ensure([],()=>r(require('@/views/fos/flowOptimization/parameterSetting')),'parameterSetting');

//应用设置
const accountManagement = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/accountManagement')),'accountManagement');



//菜单管理
const menu = r => require.ensure([],()=>r(require('@/views/fos/systermManagement/menu')),'menu');
//const property = r => require.ensure([],()=>r(require('@/views/fos/systermManagement/property')),'property');
//用户操作日志
const userLog = r => require.ensure([],()=>r(require('@/views/fos/systermManagement/userLog')),'userLog');

//应用相关管理



//网络管理
//拓扑发现
const topologyDiscovery = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/topologyDiscovery')),'topologyDiscovery');
const topologySetting = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/topologySetting')),'topologySetting');
//网络展现
const networkDisplay = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/networkDisplay')),'networkDisplay');
//应用分析
const appanalysis = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/appanalysis')),'appanalysis');
//会话检索
const ipsessionSearch = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/ipsessionSearch')),'ipsessionSearch');
//应用流管理
const appFlowManagement = r => require.ensure([],()=>r(require('@/views/fos/networkManagement/appFlowManagement')),'appFlowManagement');

//广域网加速配置
// const WANAccelerationSetting = r => require.ensure([],()=>r(require('@/views/fos/WANAcceleration/WANAccelerationSetting')),'WANAccelerationSetting');

//报警管理
const warnInfo = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/warnInfo.vue')),'warnInfo');
const warnConfig = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/warnConfig.vue')),'warnConfig');
//报警组
const warnGroup = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/warnGroup.vue')),'warnGroup');
//报警接收人员
const groupPersonnel = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/groupPersonnel.vue')),'groupPersonnel');

//报警管理 - 报警定位
const linkDetail = r =>require.ensure([],()=>r(require('@/views/fos/warnManage/linkDetail.vue')),'linkDetail')

const isReqiureLogin = false;
const routes = [
    {
        path: '/roleManage',
        component: roleManage,
        name:["用户管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/dataCenter',
        component: dataCenter,
        name:["咨询审核"],
        meta: {requireLogin: isReqiureLogin },
    },
    {
        path: '/areaCenter',
        component: areaCenter,
        name:["直推用户管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/businessManagement',
        component: businessManagement,
        name:["团队用户管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/appManagement',
        component: appManagement,
        name:["培育奖管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/createManager',
        component: createManager,
        name:["培育奖记录管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/appClassManagement',
        component: appClassManagement,
        name:["会员等级优惠"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/applicationDocuments',
        component: applicationDocuments,
        name:["月度奖励管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/toDoList',
        component: toDoList,
        name:["每月进步奖"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/appStreamQuery',
        component: appStreamQuery,
        name:["团队业绩管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/parameterSetting',
        component: parameterSetting,
        name:["交易流水管理"],
        meta: {requireLogin: isReqiureLogin },

    },
    {
        path: '/accountManagement',
        component: accountManagement,
        name:["应用设置"],
        meta: {requireLogin: isReqiureLogin },

    },
    // {
    //     path: '/accountManagement',
    //     component: accountManagement,
    //     name:["网络管理 "," 拓扑发现 "," 账号管理"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path: '/netdisplay',
    //     component: networkDisplay,
    //     name:["网络管理 "," 网络展现"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path: '/appstream',
    //     component: appFlowManagement,
    //     name:["网络管理 "," 应用流管理"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path: '/appanalysis',
    //     component: appanalysis,
    //     name:["网络管理 "," 应用分析"],
    //     meta: {requireLogin: appanalysis },
    //
    // },
    // {
    //     path: '/ipsessionSearch',
    //     component: ipsessionSearch,
    //     name:["网络管理 "," 会话检索"],
    //     meta: {requireLogin: ipsessionSearch },
    //
    // },
    //
    //
    // // {
    // //     path: '/parameterSetting',
    // //     component: parameterSetting,
    // //     name:["流量优化 / 参数设置"],
    // // },
    //
    // // {
    // //     path: '/WANAccelerationSetting',
    // //     component: WANAccelerationSetting,
    // //     name:["广域网加速 / 广域网加速配置"],
    // //     meta: {requireLogin: isReqiureLogin },
    // //
    // // },
    // {
    //     path: '/notdowork',
    //     component: toDoList,
    //     name:["申请状态 "," 待办事项"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path: '/applylist',
    //     component: applicationDocuments,
    //     name:["申请状态 "," 申请单据"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path:'/app',
    //     component:warnInfo,
    //     name:["报警管理 "," 报警信息"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path:'/group',
    //     component:warnGroup,
    //     name:["报警管理 "," 报警组"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path:'/groupPersonnel',
    //     component:groupPersonnel,
    //     name:["报警管理 "," 报警组","接收人员"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path:'/linkDetail',
    //     component:linkDetail,
    //     name:["报警管理 "," 报警定位"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // },
    // {
    //     path:'/set',
    //     component:warnConfig,
    //     name:["报警管理 "," 报警配置"],
    //     meta: {requireLogin: isReqiureLogin },
    //
    // }
]
export default  routes
