import httpService from '../http.service'

class workService {
    constructor(vueThis) {
        this.vm = vueThis;  //vue中的this  也可以不用
    }

    //这部分是请求的接口的方法

    //登录
    getTokenList(data){
        return httpService.post('api/user/userLogin' , data ? data : {} ,false)
    }

    //获取短信
    getVerify(data){
        return httpService.post('api/sms/verifyCode' , data ? data : {} ,false)
    }
    //用户列表
    getUserInfo(data){
        return httpService.get('admin/user/queryUserList' , data ? data : {} ,true)
    }
    //直推用户列表
    getRecommend(data){
        return httpService.get(`admin/user/queryRecommendUserList` , data ? data :{} ,true)
    }
    //团队列表
    getTeamUser(data){
        return httpService.get(`admin/user/queryTeamUserInfoList` , data ? data :{} ,true)
    }
    //培育奖列表
    getCultivating(data){
        return httpService.get(`admin/user/queryCultivatingPrizeInfoList` , data ? data :{} ,true)
    }

    //资讯审核表
    getShopZx(data){
        return httpService.get(`admin/ZX/queryShopZxList` , data ? data :{} ,true)
    }

    //培育奖列表
    getCtInfo(data){
        return httpService.get(`admin/user/queryCultivatingInfo` , data ? data :{} ,true)
    }

    //会员等级优惠
    getMember(data){
        return httpService.get(`admin/member/getList` , data ? data :{} ,true)
    }

   //月度奖励
    getaward(data){
        return httpService.get(`award/getList` , data ? data :{} ,true)
    }
    //每月进步奖
    getprize(data){
        return httpService.get(`admin/prize/getList` , data ? data :{} ,true)
    }
    //团队业绩
    getTeam(data){
        return httpService.get(`admin/team/queryList` , data ? data :{} ,true)
    }

    //交易流水
    getTrade(data){
        return httpService.get(`admin/trade/queryList` , data ? data :{} ,true)
    }

    //应用设置--参数配置
    setParam(data){
        return httpService.post(`admin/set/param` , data ? data :{} ,true)
    }

    //资讯审核
    setToExamine(data){
        return httpService.post(`admin/ZX/toExamine` , data ? data :{} ,true)
    }

    //上传视频
    setupload(data){
        return httpService.post(`admin/ZX/uploadVideo` , data ? data :{} ,true)
    }
    //在http.servers.js里把token赋值
    //sessionStorage.setItem('testKey','这是一个测试的value值')
    //sessionStorage.getItem('testKey');

    //登录获取token
    // getLogindata(data){
    //     return httpService.get('sys/role/list' , data ? data : {} ,true)
    // }

    //角色管理列表接口
    getRoleList(data){
        return httpService.get('sys/role/list' , data ? data : {} ,true)
    }
    //角色管理--查询
    getRoleQuery(id, data){
        return httpService.get(`sys/role/info/${id}` , data ? data :{} ,true)
    }
    //角色管理--编辑
    getRoleEdit(data){
        return httpService.put(`sys/role/update` , data ? data :{} ,true)
    }
    //角色管理--删除
    getRoleDlete(data){
        return httpService.deleteOut(`sys/role/delete` , data ? data :{} ,true)
    }
    //角色管理--新增
    getSave(data){
        return httpService.post(`sys/role/save` , data ? data :{} ,true)
    }
    //角色管理--验证
    getCheck(data){
        return httpService.get(`sys/role/check` , data ? data :{} ,true)
    }


    //管理员创建列表接口
    getNewUserList(data){
        return httpService.get('sys/user/list' , data ? data : {} ,true)
    }
    //管理员创建--新建
    getNewUserApp(data){
        return httpService.post('sys/user/save' , data ? data : {} ,true)
    }
    //管理员新建--下拉
    getRoleListData(data){
        return httpService.get('sys/role/select' , data ? data : {} ,true)
    }
    //管理员创建--查询
    getNewUserQuery(id, data){
        return httpService.get(`sys/user/info/${id}` , data ? data :{} ,true)
    }
    //管理员创建--编辑
    getNewUserEdit(data){
        return httpService.put('sys/user/update' , data ? data : {} ,true)
    }


    //管理员创建--删除
    getNewUserDelete(data){
        return httpService.deleteOut('sys/user/delete' , data ? data : {} ,true)
    }
    //管理员创建--验证
    getCheckEdit(data){
        return httpService.get('sys/user/check' , data ? data : {} ,true)
    }

    //菜单管理——列表接口
    getMenuList(data){
        return httpService.get('sys/resource/list' , data ? data : {} ,true)
    }
    //菜单管理——新增
    getMenuSave(data){
        return httpService.post('sys/resource/save' , data ? data : {} ,true)
    }
    //菜单管理——修改
    getMenuUpdate(data){
        return httpService.put('sys/resource/update' , data ? data : {} ,true)
    }
    //菜单管理——删除
    getMenuDelete(id,data){
        return httpService.deleteOut(`sys/resource/delete/${id}` , data ? data : {} ,true)
    }
    //菜单管理——下拉
    getMenuSelect(data){
        return httpService.get(`sys/resource/select` , data ? data : {} ,true)
    }
    //菜单管理——查看详情
    getMenuInfo(id,data){
        return httpService.get(`sys/resource/info/${id}` , data ? data : {} ,true)
    }



    //用户操作日志列表接口
    getUserList(data){
        return httpService.get('sys/log/list' , data ? data : {} ,true)
    }

    //应用管理列表接口
    getAppList(data){
        return httpService.get('modules/appmng/list' , data ? data : {} ,true)
    }
    //应用管理 新建
    getAppSave(data){
        return httpService.post('modules/appmng/save' , data ? data : {} ,true)
    }
    //应用管理 查看
    getAppClassSee(id,data){
        return httpService.get(`modules/appmng/info/${id}` , data ? data : {} ,true)
    }
    //应用管理--删除
    getAppDelete(data){
        return httpService.deleteOut(`modules/appmng/batch/delete` , data ? data : {} ,true)
    }
    //应用管理--判断删除接口数组
    gettestDelete(data){
        return httpService.get(`modules/appmng/testDelete` , data ? data : {} ,true)
    }
    //应用管理--判断删除接口
    getDelete(id,data){
        return httpService.get(`modules/appmng/testUpdate/${id}` , data ? data : {} ,true)
    }


    //应用类管理列表接口
    getAppClassList(data){
        return httpService.get('modules/appclass/list' , data ? data : {} ,true)
    }
    //应用类管理-- 判断修改接口
    getAppNew(id,data){
        return httpService.get(`modules/appclass/testUpdate/${id}` , data ? data : {} ,true)
    }
    //应用类管理-- 判断删除接口
    getAppDelet(data){
        return httpService.get(`modules/appclass/testDelete` , data ? data : {} ,true)
    }
    //应用类管理--查看
    getAppSee(id ,data){
        return httpService.get(`modules/appclass/info/${id}` , data ? data : {} ,true)
    }
    //应用类管理--新建
    getNewAppClass(data){
        return httpService.post('modules/appclass/save' , data ? data : {} ,true)
    }
    //应用类管理--编辑
    getNewAppEdit(data){
        return httpService.put('modules/appclass/update' , data ? data : {} ,true)
    }
    //应用类管理--删除
    getNewAppDelete(data){
        return httpService.deleteOut(`modules/appclass/batch/delete` , data ? data : {} ,true)
    }



    //数据中心管理列表接口
    getAppCenterList(data){
        return httpService.get('modules/datacenter/list' , data ? data : {} ,true)
    }
    //数据中心管理 新建
    getAppCenterSave(data){
        return httpService.post('modules/datacenter/save' , data ? data : {} ,true)
    }
    //数据中心管理 删除
    getAppCenterDel(data){
        return httpService.deleteOut('modules/datacenter/batch/delete' , data ? data : {} ,true)
    }

    //区域中心管理列表接口
    getAppAreaList(data){
        return httpService.get('modules/areacenter/list' , data ? data : {} ,true)
    }

    //区域中心管理列表--新建
    getAppareaCenter(data){
        return httpService.post('modules/areacenter/save' , data ? data : {} ,true)
    }
    //区域中心管理--删除
    getAppAreaDelete(data){
        return httpService.deleteOut(`modules/areacenter/batch/delete` , data ? data : {} ,true)
    }

    //企业管理列表接口
    getAppManagerList(data){
        return httpService.get('modules/enterprise/list' , data ? data : {} ,true)
    }
    //企业管理--查看
    getAppAreaListQurey(data){
        return httpService.get(`modules/enterprise/list` , data ? data : {} ,true)
    }
    //企业管理--新建
    getManager(data){
        return httpService.post('modules/enterprise/save' , data ? data : {} ,true)
    }
    //企业管理--删除
    getManagerDelete(data){
        return httpService.deleteOut(`modules/enterprise/batch/delete` , data ? data : {} ,true)
    }
    //应用流查询列表接口
    getFlowInfomList(data){
        return httpService.get(`modules/flowinfo/list` , data ? data : {} ,true)
    }
    //应用流管理 小拓扑
    getListTopopart(data){
        return httpService.get(`modules/topo/listtopopart` , data ? data : {} ,true)
    }



    //网络管理
    //拓扑发现
    getListtopoall(data){
        return httpService.get('modules/topo/listtopoall' , data ? data : {} ,true)
    }
    //局部拓扑查询
    getListtopopart(data){
        return httpService.get('modules/topo/listtopopart' , data ? data : {} ,true)
    }
    //拓扑发现 账号管理 列表
    getListnodeacc(data){
        return httpService.get('modules/topomade/listnodeacc' , data ? data : {} ,true)
    }

    //拓扑发现 账号管理 登录
    getMngnodeacc(data){
        return httpService.post('modules/topomade/mngnodeacc' , data ? data : {} ,true)
    }


    //拓扑发现 链路物理趋势图
    getFinkhisflow(data){
        return httpService.get('modules/exhibition/linkhisflow' , data ? data : {} ,true)
    }

    //拓扑发现 链路应用流列表
    getFlowinfo(data){
        return httpService.get('modules/exhibition/flowinfo' , data ? data : {} ,true)
    }
    //拓扑发现 子表
    getFlowlistchildview(data){
        return httpService.get('modules/exhibition/listchildview' , data ? data : {} ,true)
    }


    //拓扑发现 日志
    getFlowChangeBy(data){
        return httpService.get('modules/exhibition/flowChangeByTime' , data ? data : {} ,true)
    }

    //拓扑发现 查询应用流趋势图
    getHisflow(data){
        return httpService.get('modules/exhibition/hisflow' , data ? data : {} ,true)
    }

    //拓扑发现 ip页面趋势图
    gitApphisflow(data){
        return httpService.get('modules/exhibition/apphisflow' , data ? data : {} ,true)
    }


    //拓扑整理 查看节点信息
    getNodeSee(data){
        return httpService.get('modules/topo/info' , data ? data : {} ,true)
    }
    //拓扑整理 管理节点信息
    getNodeSave(data){
        return httpService.post('modules/topo/save' , data ? data : {} ,true)
    }
    //拓扑整理 查看配置
    getConfiginfo(data){
        return httpService.get('modules/topo/configinfo' , data ? data : {} ,true)
    }
    //网络展现 详情列表
    getFlowInfo(data){
        return httpService.get('modules/exhibition/flowinfo' , data ? data : {} ,true)
    }

    //应用流管理 企业列表查询
    getEnterpriseList(data){
        return httpService.get('modules/enterprise/list' , data ? data : {} ,true)
    }

    //应用流管理 应用流列表
    getAppStreamList(data){
        return httpService.get('modules/appstream/list' , data ? data : {} ,true)
    }

    //应用流管理 应用流列表新建
    getAppStreamSave(data){
        return httpService.post('modules/appstream/save' , data ? data : {} ,true)
    }
    //应用流管理 根据应用流查询链路（按通道）
    getLinkbytunel(data){
        return httpService.get('modules/exhibition/linkbytunel' , data ? data : {} ,true)
    }



    //应用类管理--查看
    getAppStreamSee(id ,data){
        return httpService.get(`modules/appstream/info/${id}` , data ? data : {} ,true)
    }
    //应用类管理--判断是否可以修改
    getAppStreamtestUpdate(id ,data){
        return httpService.get(`modules/appstream/testUpdate/${id}` , data ? data : {} ,true)
    }
    //应用类管理--修改
    putAppStreamUpdate(data){
        return httpService.put('modules/appstream/update' , data ? data : {} ,true)
    }
    //应用类管理--删除
    getAppStreamDelete(data){
        return httpService.deleteOut('modules/appstream/batch/delete', data ? data : {} ,true)
    }
    //应用类管理--判断是否可以删除
    getAppStreamTestDelete(data){
        return httpService.get('modules/appstream/testDelete', data ? data : {} ,true)
    }




    //待办事项
    getTodo(data){
        return httpService.get('modules/notdowork/list' , data ? data :{} ,true)
    }
    //待办事项--查询
    getTodoQuery(data){
        return httpService.get('modules/notdowork/info' , data ? data :{} ,true)
    }
    //待办事项--审批
    getTodoApprove(data){
        return httpService.post('modules/notdowork/approve' , data ? data :{} ,true)
    }

    //申请单据
    getBills(data){
        return httpService.get('modules/applylist/list' , data ? data :{} ,true)
    }
    //申请单据 -- 查询
    getQuery(data){
        return httpService.get(`modules/applylist/info` , data ? data :{} ,true)
    }


}
export  default  workService
