import axios from 'axios';
import router from '../router'
import {MessageBox} from 'element-ui';


import {NETWORK_STATUS,jsonToParams} from '../config/network.config'
let baseUrl = "http://8.131.244.76:81/shop-mall/"
// let baseUrl = "http://10.178.46.205:8086/fos/"
let token = localStorage.getItem('token')
import loadEvents  from '../utils/load'
let loading = new loadEvents()
function get(url, data, auth = false, options = {}) {
    token = localStorage.getItem('token');
    let config = {};
    url=url+jsonToParams(data);
    if (auth) {
        config = Object.assign({}, options);
        config.headers = (config.headers) ? config.headers : {};
        config.headers['token'] = token;
    }
    loading.open()
    return axios.get(baseUrl + url, config)
        .then((res) => responseHandler(res))
        .catch((err) => responseError(err));
}
function post(url, data, auth = false, options = {}) {
    token = localStorage.getItem('token');
    let config = {};
    if (auth) {
        config = Object.assign(options, {
            headers: {'token': token}
        });
    }
    loading.open()
    return axios.post(baseUrl + url, data, config)
        .then((res) => responseHandler(res))
        .catch((err) => responseError(err));
}
function put(url, data, auth = false, options = {}) {
    token = localStorage.getItem('token');
    let config = {};
    if (auth) {
        config = Object.assign(options, {
            headers: {'token': token}
        });
    }
    loading.open()
    return axios.put(baseUrl + url, data, config)
        .then((res) => responseHandler(res))
        .catch((err) => responseError(err));
}
function deleteOut(url, data, auth = false, options = {}) {
    url = url + jsonToParams(data);
    token = localStorage.getItem('token');
    let config = {};
    if (auth) {
        config = Object.assign(options, {
            headers: {'token': token}
        });
    }
    loading.open()
    return axios.delete(baseUrl + url,config)
        .then((res) => responseHandler(res))
        .catch((err) => responseError(err));
}

function deleteput(url, data, auth = false, options = {}) {
    token = localStorage.getItem('token');
    let config = {};
    if (auth) {
        config = Object.assign({data:data}, {
            headers: {'token': token}
        });
    }
    loading.open()
    return axios.delete(baseUrl + url,config)
        .then((res) => responseHandler(res))
        .catch((err) => responseError(err));
}

function responseError(err) {
    loading.close()
    return Promise.reject(err);
}

function responseHandler(res,options) {
    if(options != 1){
        loading.close()
    }
    if(typeof(res.data)=="string"){
        if(res.data!=""){
            res.data=JSON.parse(res.data)
        }
    }
    if(res.data.code == 401){
        if(localStorage.getItem('token')){
            //这个时候点击确定后清除用户信息
            localStorage.removeItem('token')
            MessageBox.alert('您的登录过期，请重新登录!', '提示', {
                confirmButtonText: '确定',
                callback: () => {
                    router.push('login')
                }
            });
        }
    }
    return Promise.resolve(res.data);
}

export default {get, post, deleteOut, put, deleteput}
