import httpService from './http.service'

class vpnService {
  constructor(vueThis) {
    this.vm = vueThis;  //vue中的this  也可以不用
  }
  //vpn列表
  getVpnList(data){
    return httpService.get(`modules/instance/list` , data ? data : {} , true)
  }
  //查询新的vpn名称
  getNewName(data){
    return httpService.get(`modules/instance/name/list`, data ? data : {} , true)
  }
  //根据vpnName 查询已经部署设备和操作历史
  getDetailByVpnName(vpnName,data){
    return httpService.get(`modules/instance/detail/${vpnName}` , data ? data : {} , true)
  }
  //新增vpn
  saveVpn(data){
    return httpService.post(`modules/instance/save` , data ? data : {} , true)
  }
  //更新vpn
  updateVpn(data){
    return httpService.post(`modules/instance/update` , data ? data : {} , true)
  }
  //根据detailId 查询设备部署分析列表
  getDeployByDetailId(data){
    return httpService.get(`modules/instance/detail` , data ? data : {} , true)
  }
  //删除某个设备
  deleteVpn(vpnName,data){
    return httpService.post(`modules/instance/delete/${vpnName}` , data ? data : {} , true)
  }
  //vpn 添加设备列表
  getDeviceListByVpnName(data){
    return httpService.get(`modules/instance/device/list` , data ? data : {} , true)
  }
  //vpn 拓扑列表
  getTopoList(data){
    return httpService.post(`modules/instance/topo/list` , data ? data : {} , true)
  }

  //vpn添加设备列表或者重新部署   添加设备（不需要提交detailID），重新部署（只需要提交detailID
  vpnAddOrDepolyDevice(data){
    return httpService.post(`modules/instance/device/save` , data ? data : {} , true)
  }

  //用户信息回显
  getUserInfoList(userName,data) {
    return httpService.get(`modules/instance/info/list/${userName}`, data ? data : {} , true)
  }


}
export  default  vpnService
