import Vue from 'vue'
import Vuex from 'vuex'

Vue.use(Vuex)

export default new Vuex.Store({
  state: {
    configCode: "",
    topuCheckId:[],
    topuRetNode:[],

    editNode:false,
    setArea:false,
    accId:"",
    formShow:false,
    nodeIP:"",
    nodeObj:{},
    flowShow:false,
    netListShow:false,
    editBWShow:false,
    edgesId:"",

    addWarnShow:false,
    addAppShow:false,
  },
  getters:{
    getCheckId(state){
      return state.topuCheckId;
    },
    getRetNode(state){
      return state.topuRetNode
    }
  },
  mutations: {
    updateConfigCode (state, code) {
      state.configCode = code
    },
    updateCheckId (state, ids) {
      state.topuCheckId = ids
    },
    updateRetNode(state,node){
      state.topuRetNode = node
    },
    // fos项目
    //拓扑发现
    updateFormShow(state,node){
        state.formShow = node
    },
    //拓扑管理
    updateEditNode(state,node){
        state.editNode = node
    },
    //拓扑管理 节点IP
    updateNodeIP(state,ip){
        state.nodeIP = ip
    },
    //拓扑管理 节点信息
    updateNodeMsg(state,obj){
        state.nodeObj = obj
    },
    //拓扑管理 设置节点区域
    updateSetArea(state,node){
        state.setArea = node
    },
    updateAccId(state,id){
        state.accId = id
    },
    // 拓扑整理 修改带宽
    editBWShow(state,node){
      state.editBWShow = node
    },

    //网络展现
    updateNetListShow(state,node){
        state.netListShow = node
    },
    updateEdgesId(state,id){
        state.edgesId = id
    },

    // 报警组 添加报警对象
    addWarnShow(state,node){
      state.addWarnShow = node
    },
    // 报警组 添加应用对象
    addAppShow(state,node){
      state.addAppShow = node
    }


  },
  actions: {

  }
})
