/**
 * 邮箱
 * @param {*} s
 */
function isEmail (s) {
    return /^[A-Za-z0-9]+([-_.][A-Za-z0-9]+)*@([A-Za-z0-9]+[-.])+[A-Za-z0-9]{2,4}$/.test(s)
   }
   
   /**
    * 手机号码
    * @param {*} s
    */
   function isMobile (s) {
     return /^1[0-9]{10}$/.test(s)
   }
   
   /**
    * 手机号
    * @param {*} s
    */
   function isPhone (s) {
     return /^1[34578]\d{9}$/.test(s)
   }
   
   /**
    * URL地址
    * @param {*} s
    */
   function isURL (s) {
     return /^((https|http|ftp|rtsp|mms){0,1}(:\/\/){0,1})www\.(([A-Za-z0-9-~]+)\.)+([A-Za-z0-9-~\/])+$/.test(s)
   }
   
   /**
    * 用户名 英文数字下划线
    * @param {*} s
    */
   function isUserName (s) {
    return /^[a-zA-Z0-9_\.\-]*$/.test(s)
  }
  
   /**
    * 用户名 英文数字
    * @param {*} s
    */
   function isUser (s) {
    return /^[a-zA-Z0-9]*$/.test(s)
  }
   
   
   /**
    * 路径 sd/asd/sda.vue
    * @param {*} s
    */
   function isPath(s) {
     return /[\w\.]+\/{1}[\w+\.]/.test(s)
   }
   
   /**
    * 备注 中文英文数字下划线和.
    * @param {*} s
    */
   function isRemarks (s) {
     return /^[\.\，\。\：\-\w\u4e00-\u9fa5]*$/.test(s)
   }

   /**
    * 用户名中文  中文英文数字下划线和.
    * @param {*} s
    */
   function isChinaName (s) {
    return /^[\.\_\-\w\u4e00-\u9fa5]*$/.test(s)
  }
  
   /**
    * IP
    * @param {*} s
    */
   function isIp (s) {
     return /^(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))$/.test(s)
   }
   
   /**
    * 端口
    * @param {*} s
    */
   function isDuankou (s) {
     return /^([0-9]|[1-9]\d{1,3}|[1-5]\d{4}|6[0-5]{2}[0-3][0-5])$/.test(s)
   }
   
   /**
    * Mac
    * @param {*} s
    */
   function isMac (s) {
     return /(([a-f0-9]{2}:)|([a-f0-9]{2}-)){5}[a-f0-9]{2}/gi.test(s)
   }
   
   /**
    * 数字
    * @param {*} s
    */
   function isNumder (s) {
     return /^-?\d+$/.test(s)
   }
   
   /**
    * 坐标
    * @param {*} s
    */
   function isXY (s) {
     return /^[-\+]?\d+(\.\d+)$/.test(s)
   }
   
   /**
    * IP集合
    * @param {*} s
    */
   function isIPlist (s) {
     return /^(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))(,(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))))))*?$/
     .test(s)
   }
   
   /**
    * URL adress地址
    * @param {*} s
    */
   function isurlAddress (s) {
     return /^((https|http|ftp|rtsp|mms){0,1}(:\/\/){0,1})(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))(\:[0-9]+)(\/\w+){1,}(\/\w+\.?\w+)?(\?\w+|\w*)?$/.test(s)
   }
   
   /**
    * IP段
    * @param {*} s
    */
   function isIPScanner (s) {
    return /^(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))-(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))(,(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))-(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))))))*?$/.test(s)
  }

   /**
    * 座机
    * @param {*} s
    */
   function isTel (s) {
    return /^\d{2,5}-\d{7,8}$/.test(s)
  }


   export default {isEmail,isMobile, isPhone, isURL, isUserName,isUser,isPath,isRemarks,isIp,isDuankou,isMac,isNumder,isXY,isIPlist,isurlAddress,isIPScanner,isChinaName,isTel}
   
   
   
   
   
   