import validate from './validate'
 let vm;
 let pattern_dstIP = /^(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))$/;
 let pattern_vpnIp = /^(((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d))+\/([0-9]{1,3})))|((?:(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))\.){3}(?:25[0-5]|2[0-4]\d|((1\d{2})|([1-9]?\d)))))\/([1-9]{1}|1[0-9]{1}|2[0-9]{1}|30|31)$/;
 let pattern_dstMask =  /^([0-9]?|1[0-9]{1}|2[0-9]{1}|30|31|32)$/;
 let pattern_remark =  /^[_.\n\w\u4e00-\u9fa5]*$/;
 /[1-4]0[0-9][0-4]/
 let ValidatorEvent = {

     getVueThis:function(vuethis){
         vm = vuethis
     },
     //业务校验开始
     validatorIP:function(rule, value, callback){
         if(value){
             if(pattern_vpnIp.test(value)){
                 callback()
             }else {
                 callback(new Error('请输入正确格式的Ip地址'));
             }
         }else {
             callback(new Error('请输入Ip地址'));
         }
     },
    //校验vlan vlanNum (string, optional): vlan号（vpn的场景是子接口场景或vlan场景时，必输） ,
     validatorVlan:function(rule, value, callback) {
        if(vm.ifType=='2'||vm.ifType=='3'){
            if (!value) {
               callback(new Error('请输入vlan号'));
            }else {
                if(value < 1 || value >4094){
                    callback(new Error('请输入vlan号,范围1-4094'));
                }else {
                    callback()
                }
            }
        }else {
            callback()
        }
     },
     //校验下一跳IP地址
     validatorNextIp:function(rule, value, callback) {
         if(vm.form.isStaticRoute==1){
             if (!value) {
                 callback(new Error('请输入下一跳IP地址'));
             }else {
                 if(pattern_dstIP.test(value)){
                     callback()
                 }else {
                     callback(new Error('请输入正确格式的下一跳IP地址'));
                 }
             }
         }else {
             callback()
         }

     },
     //校验目的网段IP
     validatorTargetIp:function(rule, value, callback) {
         if(vm.form.isStaticRoute==1){
             if (!value) {
                 callback(new Error('请输入目的网段IP'));
             }else {
                 if(pattern_dstIP.test(value)){
                     callback()
                 }else {
                     callback(new Error('请输入正确格式的目的网段IP'));
                 }
             }
         }else {
             callback()
         }
     },
     //校验目的网段掩码
     validatorTargetMask:function(rule, value, callback) {
         if(vm.form.isStaticRoute==1){
             if (!value) {
                 callback(new Error('请输入目的网段掩码'));
             }else {
                 if(pattern_dstMask.test(value)){
                     callback()
                 }else {
                     callback(new Error('请输入正确格式的目的网段掩码'));
                 }
             }
         }else {
             callback()
         }
     },
     //校验虚拟IP
     validatorVirtualIp:function(rule, value, callback) {
         if(vm.form.isVrrp==1){
             if (!value) {
                 callback(new Error('请输入虚拟IP'));
             }else {
                 if(pattern_dstIP.test(value)){
                     callback()
                 }else {
                     callback(new Error('请输入正确格式的虚拟IP'));
                 }
             }
         }else {
             callback()
         }
     },
     //校验优先级
     validatorPriority:function(rule, value, callback) {
         if(vm.form.isVrrp==1){
             if (!value) {
                 callback(new Error('请输入优先级'));
             }else {
                 if(value <1 ||value > 254){
                     callback(new Error('请输入优先级,范围1-254'));
                 }else {
                     callback()
                 }
             }
         }else {
             callback()
         }
     },
     //业务校验结束
     //校验优先级
    validatePassx:function(rule, value, callback){
        if (value !== '') {
            // callback(new Error('请输入密码'));
            if (!validate.isUserName(value)) {
                callback(new Error('只可输入英文数字下划线!'));
            }else if (vm.form.pwdsx !== '') {
                vm.$refs.form.validateField('pwdsx');
                callback();
            }
            callback();
        }else{
            callback();
        }
    },
    validatePass2x:function(rule, value, callback){
        if(!vm.isEdit){
            callback();
        }else if (!validate.isUserName(value)) {
            callback(new Error('只可输入英文数字下划线!'));
        }else
        if (value != vm.form.pwdx) {
            callback(new Error('两次输入密码不一致!'));
        }else {
            callback();
        }
    },

    validatePass:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入密码'));
        }
         else if (!validate.isUserName(value)) {
            callback(new Error('只可输入英文数字下划线!'));
        }else{
        if (vm.form.pwds !== '') {
            vm.$refs.form.validateField('pwds');
        }
        callback();
        }
    },
    validatePass2:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请再次输入密码'));
        }
         else if (!validate.isUserName(value)) {
            callback(new Error('只可输入英文数字下划线!'));
        }else if (value !== vm.form.pwd) {
        callback(new Error('两次输入密码不一致!'));
        } else {
        callback();
        }
    },



    // 邮箱
    vEmail:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入邮箱'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isEmail(value)) {
            callback(new Error('请输入正确的邮箱!'));
        } else {
        callback();
        }
    },
    // 座机
    vTel:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入手机号'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isTel(value)) {
            callback(new Error('请输入正确的手机号!'));
        } else {
        callback();
        }
    },
    // 手机号码不限开头
    vMobile:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入手机号'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isMobile(value)) {
            callback(new Error('请输入正确的手机号!'));
        } else {
        callback();
        }
    },
    // 手机号 34578 限制
    vPhone:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入手机号'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isPhone(value)) {
            callback(new Error('请输入正确的手机号!'));
        } else {
        callback();
        }
    },
    //  URL地址
    vURL:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入URL地址'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isURL(value)) {
            callback(new Error('请输入正确的URL地址!'));
        } else {
        callback();
        }
    },
    // 用户名 英文数字
    vUser:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入用户名'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isUser(value)) {
            callback(new Error('请输入正确的用户名(英文数字)!'));
        } else {
        callback();
        }
    },
    // 用户名 英文数字下划线
    vUserName:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入用户名'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isUserName(value)) {
            callback(new Error('请输入正确的用户名(英文数字下划线)!'));
        } else {
        callback();
        }
    },
    // 用户名 中文英文数字下划线
    vChinaUserName:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入用户名'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isChinaName(value)) {
            callback(new Error('请输入正确的用户名(中文英文数字下划线)!'));
        } else {
        callback();
        }
    },
    
    // 路径 sd/asd/sda.vue
    vPath:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入路径地址'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isPath(value)) {
            callback(new Error('请输入正确的路径地址!'));
        } else {
        callback();
        }
    },
    // 备注 中文英文数字下划线和.
    vRemarks:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入备注'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isRemarks(value)) {
            callback(new Error('请输入正确的备注(中文英文数字下划线和.)!'));
        } else {
        callback();
        }
    },
    // IP
    vIp:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入IP'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isIp(value)) {
            callback(new Error('请输入正确的IP!'));
        } else {
        callback();
        }
    },
    // 端口
    vDuankou:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入端口'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isDuankou(value)) {
            callback(new Error('请输入正确的端口!'));
        } else {
        callback();
        }
    },
    // Mac
    vMac:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入Mac'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isMac(value)) {
            callback(new Error('请输入正确的Mac!'));
        } else {
        callback();
        }
    },
    // 数字
    vNumder:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入数字'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isNumder(value)) {
            callback(new Error('仅限输入数字!'));
        } else {
        callback();
        }
    },
    // 坐标
    vXY:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入坐标'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isXY(value)) {
            callback(new Error('请输入正确的坐标!'));
        } else {
        callback();
        }
    },
    // IP集合
    vIPlist:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入IP组'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isIPlist(value)) {
            callback(new Error('请输入正确的IP组!'));
        } else {
        callback();
        }
    },
    // URL adress地址
    vurlAddress:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入URL adress地址'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isurlAddress(value)) {
            callback(new Error('请输入正确的URL adress地址!'));
        } else {
        callback();
        }
    },
    // IP段
    vIPScanner:function(rule, value, callback){
        if (rule.required && value === '') {
            callback(new Error('请输入Ip段'));
        }else if(!rule.required && value === ''){
            callback();
        }
         else if (!validate.isIPScanner(value)) {
            callback(new Error('请输入正确的Ip段!'));
        } else {
        callback();
        }
    },

}
 export  default ValidatorEvent
